import express from 'express';
import db from './db.js';

const router = express.Router();

// إضافة فرع جديد
router.post('/add', async (req, res) => {
  const { alfr1, alaqsam_id } = req.body;

  try {
    const [result] = await db.query('INSERT INTO alfro (alfr1, alaqsam_id) VALUES (?, ?)', [alfr1, alaqsam_id]);
    res.json({ message: 'تم إضافة الفرع بنجاح!', id: result.insertId });
  } catch (error) {
    res.status(500).json({ message: 'حدث خطأ أثناء إضافة الفرع.' });
  }
});

// جلب جميع الفروع مع الأقسام المرتبطة بها
router.get('/', async (req, res) => {
  try {
    const [rows] = await db.query(`
      SELECT alfro.id, alfro.alfr1, alaqsam.qsm, alaqsam.id as alaqsam_id 
      FROM alfro 
      JOIN alaqsam ON alfro.alaqsam_id = alaqsam.id
    `);
    res.json(rows);
  } catch (error) {
    res.status(500).json({ message: 'حدث خطأ أثناء جلب الفروع.' });
  }
});

// تعديل فرع
router.put('/edit/:id', async (req, res) => {
  const { id } = req.params;
  const { alfr1, alaqsam_id } = req.body;

  try {
    await db.query('UPDATE alfro SET alfr1 = ?, alaqsam_id = ? WHERE id = ?', [alfr1, alaqsam_id, id]);
    res.json({ message: 'تم تعديل الفرع بنجاح!' });
  } catch (error) {
    res.status(500).json({ message: 'حدث خطأ أثناء تعديل الفرع.' });
  }
});

// حذف فرع
router.delete('/delete/:id', async (req, res) => {
  const { id } = req.params;

  try {
    await db.query('DELETE FROM alfro WHERE id = ?', [id]);
    res.json({ message: 'تم حذف الفرع بنجاح!' });
  } catch (error) {
    res.status(500).json({ message: 'حدث خطأ أثناء حذف الفرع.' });
  }
});

export default router;
