import express from 'express';
import db from './db.js';

const router = express.Router();

// إضافة موديل جديد
router.post('/add', async (req, res) => {
  const { mdl } = req.body;

  try {
    const [result] = await db.query('INSERT INTO model (mdl) VALUES (?)', [mdl]);
    res.json({ message: 'تمت إضافة موديل السنة بنجاح!', id: result.insertId });
  } catch (error) {
    res.status(500).json({ message: 'حدث خطأ أثناء إضافة موديل السنة.' });
  }
});

// جلب جميع الموديلات
router.get('/', async (req, res) => {
  try {
    const [rows] = await db.query('SELECT * FROM model');
    res.json(rows);
  } catch (error) {
    res.status(500).json({ message: 'حدث خطأ أثناء جلب موديلات السنة.' });
  }
});

// تعديل موديل السنة
router.put('/edit/:id', async (req, res) => {
  const { id } = req.params;
  const { mdl } = req.body;

  try {
    await db.query('UPDATE model SET mdl = ? WHERE id = ?', [mdl, id]);
    res.json({ message: 'تم تعديل موديل السنة بنجاح!' });
  } catch (error) {
    res.status(500).json({ message: 'حدث خطأ أثناء تعديل موديل السنة.' });
  }
});

// حذف موديل السنة
router.delete('/delete/:id', async (req, res) => {
  const { id } = req.params;

  try {
    await db.query('DELETE FROM model WHERE id = ?', [id]);
    res.json({ message: 'تم حذف موديل السنة بنجاح!' });
  } catch (error) {
    res.status(500).json({ message: 'حدث خطأ أثناء حذف موديل السنة.' });
  }
});

export default router;
