//const Jimp = (await import('jimp')).default;
//import * as Jimp from 'jimp';
import path from 'path'; 
import Jimp from 'jimp/es';


const addWatermark = async (filePath, outputDir, watermarkText) => {
  const image = await Jimp.read(filePath); // قراءة الصورة
  const font = await Jimp.loadFont(Jimp.FONT_SANS_32_WHITE); // تحميل خط العلامة المائية

  // إضافة النص كعلامة مائية
  image.print(font, 10, 10, watermarkText); // 10 و 10 لتحديد موضع النص

  // حفظ الصورة مع العلامة المائية
  const outputFilePath = path.join(outputDir, path.basename(filePath));
  await image.writeAsync(outputFilePath);

  return outputFilePath; // إرجاع المسار الجديد للصورة
};

export default addWatermark;
