import axios from 'axios';

// استرجاع معلومات المصادقة
export const getAuthDetails = async () => {
  try {
    const response = await axios.get('http://localhost:3001/api/protected', {
      withCredentials: true, // إرسال الكوكيز
    });
    return { role: response.data.role, isMaintenance: response.data.isMaintenance || false };
  } catch (error) {
    throw new Error(error.response?.data?.message || 'Authentication failed');
  }
};

// تسجيل الخروج
export const logout = async () => {
  try {
    await axios.post('http://localhost:3001/api/logout', {}, { withCredentials: true });
  } catch (error) {
    throw new Error(error.response?.data?.message || 'Logout failed');
  }
};
